-- AutoEquip
--
-- Written by Thott
--
-- This uses some core Thottbot routines to prevent duplicate scans.

function AutoEquip_OnLoad()
	local ChatExtensions_Commands = {};
	local id,func,comlist,desc;

	Cosmos_RegisterConfiguration("COS_AE",
		"SECTION",
		AUTOEQUIP_SEP,
		AUTOEQUIP_SEP_INFO
		);
	Cosmos_RegisterConfiguration("COS_AE_SECTION",
		"SEPARATOR",
		AUTOEQUIP_SEP,
		AUTOEQUIP_SEP_INFO
		);
	Cosmos_RegisterConfiguration("COS_AE_STANCE",
		"CHECKBOX",
		AUTOEQUIP_CHECK,
		AUTOEQUIP_CHECK_INF0,
		AutoEquip_StanceEquipEnable,
		0,
		1
		);
--	Cosmos_RegisterConfiguration("COS_AE_CACHE",
--		"CHECKBOX",
--		"Cache worn items for faster switching",
--		"",
--		AutoEquip_CacheEquipEnable,
--		0,
--		1
--		);
	id = "TEQUIP";
	func = function(msg)
		Equip(msg);
	end
	Cosmos_RegisterChatCommand ( id, AUTOEQUIP_EQUIP_COMM, func, AUTOEQUIP_EQUIP_COMM_INFO );
	id = "TUNEQUIP";
	func = function(msg)
		Unequip(msg);
	end
	Cosmos_RegisterChatCommand ( id, AUTOEQUIP_UNEQUIP_COMM, func, AUTOEQUIP_UNEQUIP_COMM_INFO );
	id = "TUSE";
	func = function(msg)
		UseItem(msg);
	end
	Cosmos_RegisterChatCommand ( id, AUTOEQUIP_USE_COMM, func, AUTOEQUIP_USE_COMM_INFO );
	id = "TUSETYPE";
	func = function(msg)
		UseItemByType(msg);
	end
	Cosmos_RegisterChatCommand ( id, AUTOEQUIP_USETYPE_COMM, func, AUTOEQUIP_USETYPE_COMM_INFO );

--	comlist = {"/swap"};
--	desc	= "/swap <item name>,<item name> - swaps the two named items";
--	id = "TUNEQUIP";
--	func = function(msg)
--		Swap(msg);
--	end
--	Cosmos_RegisterConfigurationChatCommand ( id, comlist, func, desc );
	id = "TSEQUIP";
	func = function(msg)
		SaveSet(msg);
	end
	Cosmos_RegisterChatCommand ( id, AUTOEQUIP_SSET_COMM, func, AUTOEQUIP_SSET_COMM_INFO );
	id = "TLEQUIP";
	func = function(msg)
		LoadSet(msg);
	end
	Cosmos_RegisterChatCommand ( id, AUTOEQUIP_LSET_COMM, func, AUTOEQUIP_LSET_COMM_INFO );
	comlist = {"/listsets"};
	desc	= "Lists all saved equipment sets";
	id = "TLSETS";
	func = function(msg)
		ListSets(msg);
	end
	Cosmos_RegisterChatCommand ( id, comlist, func, desc );
	comlist = {"/delset"};
	desc	= "/delset <name>, deletes the named equipment set";
	id = "TDSETS";
	func = function(msg)
		DelSet(msg);
	end
	Cosmos_RegisterChatCommand ( id, comlist, func, desc );
	EquipmentSets = {};
	RegisterForSave("EquipmentSets");
	this:RegisterEvent("UPDATE_BONUS_ACTIONBAR");
	Cosmos_Schedule(0.5,AutoEquip_Running);
end
function UseItem(msg, numberOfTimes)
	local usedNumberOfTimes = 0;
	if ( not numberOfTimes ) then
		numberOfTimes = 1;
	end
	for i = 1, 19, 1 do
		if (strupper(GetItemName(-1, i)) == strupper(msg)) then
			UseInventoryItem(y);
			usedNumberOfTimes = usedNumberOfTimes + 1;
			if ( usedNumberOfTimes >= numberOfTimes ) then
				return true;
			end
		end
	end
	for i = 0, 4, 1 do
		for y = 1, 16, 1 do
			if (strupper(GetItemName(i, y)) == strupper(msg)) then
				UseContainerItem(i, y);
				usedNumberOfTimes = usedNumberOfTimes + 1;
				if ( usedNumberOfTimes >= numberOfTimes ) then
					return true;
				end
			end
		end
	end
	Print("Unknown Item !");
	return false;
end
function UseItemByType(msg, numberOfTimes)
	local usedNumberOfTimes = 0;
	if ( not numberOfTimes ) then
		numberOfTimes = 1;
	end
	for i = 0, 4, 1 do
		for y = 1, 16, 1 do
			if (strupper(ClassifyItem(i, y)) == strupper(msg)) then
				UseContainerItem(i, y);
				usedNumberOfTimes = usedNumberOfTimes + 1;
				if ( usedNumberOfTimes >= numberOfTimes ) then
					return true;
				end
			end
		end
	end
	Print("There's no items corresponding to the '"..msg.."' type !");
	return false;
end
function AutoEquip_Running()
	if(UnitName("player") == "Unknown Being") then
		Cosmos_Schedule(0.5,AutoEquip_Running);
		return;
	end
	AutoEquip.Running = true;
	AutoEquip.Stance = AutoEquip_Stance();
	AutoEquip.Player = UnitName("player");
	if(not EquipmentSets[AutoEquip.Player]) then
		EquipmentSets[AutoEquip.Player] = {};
	end
end
function AutoEquip_OnEvent(event)
	DebugPrint("AE event: "..event);
	if(event == "UPDATE_BONUS_ACTIONBAR") then
		AutoEquip_Actionbar();
	end
end
function ListSets()
	Print("Equipment sets:");
	for key,value in EquipmentSets[AutoEquip.Player] do
		Print("- ",key);
	end
end
function DelSet(msg)
	local setname = GetSetName(msg);
	if(not setname) then
		Print("Usage: /delset <set name>");
		return;
	end
	if(not EquipmentSets[AutoEquip.Player][setname]) then
		Print("Equipment set \"",msg,"\" not found!");
		return;
	end
	EquipmentSets[AutoEquip.Player][setname] = nil;
	Print("Equipment set \"",msg,"\" deleted.");
end
-- returns false if an error occurs
function LoadSet(msg,nocomplain)
	--dprint("LoadSet(",msg,")");
	local setname = GetSetName(msg);
	if(not setname) then
		Print("Usage: /loadset <set name>");
		return false;
	end
	if(CursorHasItem()) then
		Print("It looks like you're already holding something, aborting loadset.");
		return false;
	end
	if(not EquipmentSets[AutoEquip.Player][setname]) then
		if(not nocomplain) then
			Print("Equipment set \""..msg.."\" not found!");
			return false;
		end
		return true;
	end
	local SetID_Name = EquipmentSets[AutoEquip.Player][setname];
	local SetName_ID = {};
	for invid,itemname in SetID_Name do
		SetName_ID[itemname] = invid;
	end
	Thottbot_DoScans();
	local retval = true;
	-- shield/2h weapon handling
	if(SetID_Name[17] and SetID_Name[17] == "") then
		-- no offhand item in new set
		-- check to see if shield slot is used elsewhere for some reason
		if(InventoryID_Name[17] and SetName_ID[InventoryID_Name[17]]) then
			--dprint("Offhand used elsewhere, leaving in place");
		else
			-- shield slot isn't used, go ahead and remove it now
			--dprint("Removing offhand");
			InventoryID_Name[17] = nil;
			if(not UnequipID(17)) then
				--dprint("error occurred during offhand UnequipID(17)");
				retval = false;
			end
		end
	else
		--dprint("shield slot used in new set: ",SetID_Name[17]);
	end
	for invid,itemname in SetID_Name do
		----dprint("LoadSet: ",invid,",",itemname);
		if(InventoryName_ID[itemname] and InventoryName_ID[itemname] == invid) then
			----dprint(itemname," already equipped");
			-- do nothing, already equipped
		elseif(InventoryID_Name[invid] and InventoryID_Name[invid] == itemname) then
			-- do nothing, already equipped
		elseif(itemname == "") then
			-- it's possible that this item is later used in another slot
			local thisitem = InventoryID_Name[invid];
			if(not ContainerItem[thisitem] and 
				 SetName_ID[thisitem] and SetName_ID[thisitem] > invid and not InventoryID_Name[SetName_ID[thisitem]]) then
				-- item is used in another slot and doesn't already exist in inventory,
				-- nor is it already in that new slot
				--dprint("not removing ",thisitem," because it is used in a later slot");
			else
				if(not InventoryID_Name[invid]) then
				----dprint("not unequipping ",invid,", nothing there");
				else
					----dprint("unequip by id");
					if(not UnequipID(invid)) then
						--dprint("error occurred during UnequipID(",invid,")");
						retval = false;
					end
				end
			end
		else
			if(ContainerItem[itemname]) then
				-- check to see if the old item should be moved to another slot
				local newid = SetName_ID[InventoryID_Name[invid]];
				local newitemname = InventoryID_Name[invid];
				--dprint("Checking to see if item in slot ",invid," (which I believe to be ",newitemname,") needs to be moved somewhere");
				if(newid) then
					--dprint("I want to move the item in invid ",invid," to ",SetName_ID[InventoryID_Name[invid]]);
					-- first get rid of the target item
					if(InventoryID_Name[newid]) then
						--dprint("Removing item id ",newid,", name ",InventoryID_Name[newid]);
						PickupInventoryItem(newid);
						if(not BagItem(InventoryID_Name[newid])) then
							--dprint("error occurred during swapping bagitem");
							retval = false;
						end
					end
					-- now the destination should be "clear", do the swap
					--dprint("Moving item in id ",invid," to ",newid);
					PickupInventoryItem(invid);
					PickupInventoryItem(newid);
					-- item should be moved, now update data structures
					InventoryID_Name[newid] = newitemname;
					InventoryName_ID[newitemname] = newid;
					InventoryID_Name[invid] = nil;
					--dprint("done");
				end
				local f = pop2(ContainerItem[itemname]);
				--dprint("Equipping ",itemname," from bag slot ",f[1],",",f[2]);
				PickupContainerItem(f[1],f[2]);
				PickupInventoryItem(invid);
				if(ContainerItem[itemname].n == 0) then
					ContainerItem[itemname] = nil;
				end
				--BagItem(itemname);
				--Equip(itemname);
			elseif(InventoryName_ID[itemname]) then
				-- for switching weapons
				-- see if the current item is used in the new set
				-- if it is, we'll assume the two items can be swapped,
				-- since I can't think of any current exceptions
				local swap = false;
				for i,j in SetID_Name do
					if(InventoryName_ID[itemname] == i) then
						if(invid == InventoryName_ID[j]) then
							-- the items need to be swapped
							swap = j;
							break;
						end
					end
				end
				if(swap) then
					PickupInventoryItem(InventoryName_ID[itemname]);
					PickupInventoryItem(invid);
					local swapid = InventoryName_ID[itemname];
					InventoryName_ID[itemname] = invid;
					InventoryName_ID[swap] = swapid;
					--dprint("Swapped ",itemname," with ",swap);
				else
					-- not swapping, so remove current, then move new to here
					if(not UnequipID(invid)) then
						--dprint("error occurred during second UnequipID(",invid,")");
						retval = false;
					end
					PickupInventoryItem(InventoryName_ID[itemname]);
					PickupInventoryItem(invid);
					--dprint("Unequipped invid ",invid,", then moved worn item ",itemname," to this slot (",invid,")");
					InventoryID_Name[invid] = itemname;
					InventoryName_ID[itemname] = invid;
				end
			end
		end
	end
	Thottbot.NeedScanProfile = true;
	return retval;
end
function GetSetName(msg)
	return msg;
--	if(msg) then
--		local i,j,number = string.find(msg,"(%d)");
--		if(number) then
--			number = number + 0;
--			if(number >= 1 and number <= 4) then
--				return number;
--			end
--		end
--	end
end
function SaveSet(msg)
	----dprint("SaveSet(",msg,")");
	local setname = GetSetName(msg);
	if(setname) then
		if(not EquipmentSets[AutoEquip.Player]) then
			Print("Initalization error.");
			return;
		end
		AutoEquip.Set = Thottbot_Profile("player");
		EquipmentSets[AutoEquip.Player][setname] = AutoEquip.Set;
	else
		Print("Usage: /saveset <set number (1-4)>");
	end
end
function AutoEquip_SaveSet(setname,settable)
	local v = "";
	if(not settable) then
		----dprint("settable is nil in SaveSet ",varnum,", ",setname);
		return;
	end
	EquipmentSets[AutoEquip.Player][setname] = settable;
--	for i=1, 19, 1 do
--		j = settable[i];
--		if(j) then
--			v = v .. TID("T",j);
--		else
--			v = v .. TID("T","");
--		end
--	end
--	Cosmos_RegisterCVar("COS_AE"..setname,v);
--	Cosmos_SetCVar("COS_AE"..setname,v);
--	--dprint("saved: ",setname);
end
--function GetAEID(id)
--	return AEV[id];
--end
--function AEID(value)
--	if(not AIT) then
--		AIT = {};
--		AIT.n = 0;
--		RegisterCVar("COS_AE_IN",0);
--	end
--	if(AIT[value]) then
--		return AIT[value];
--	end
--	AIT.n = AIT.n + 1;
--	----dprint("Storing AEID ",AIT.n," => ",value);
--	RegisterCVar("COS_AE_I"..AIT.n,value);
--	SetCVar("COS_AE_I"..AIT.n,value);
--	SetCVar("COS_AE_IN",AIT.n);
--	AIT[value] = AIT.n;
--	return AIT.n;
--end
function Equip(msg, quiet)
	if(not msg or msg == "") then
		if (not quiet) then
			Print("Usage: /equip <item name>");
		end
		return;
	end
	if(CursorHasItem()) then
		if (not quiet) then
			Print("It looks like you're already holding something.");
		end
		return;
	end
	if(not ContainerItem) then
		Thottbot_ScanBags();
	end
	local c;
	if(ContainerItem[msg]) then
		c = pop2(ContainerItem[msg]);
	end
	if(not c) then
		if(Thottbot.NeedScanBags) then
			Thottbot_ScanBags();
			if(ContainerItem[msg]) then
	c = pop2(ContainerItem[msg]);
			end
		end
		if(not c) then
			if (not quiet) then
				Print("Item \""..msg.."\" not found!");
			end
			return;
		end
	end
	--dprint("Equipping ",msg);
	PickupContainerItem(c[1],c[2]);
	AutoEquipCursorItem();
	Thottbot.NeedScanBags = true;
	Thottbot.NeedScanProfile = true;
	if(ContainerItem[msg].n == 0) then
		ContainerItem[msg] = nil;
	end
	return true;
end
function Unequip(msg)
	if(not msg or msg == "") then
		Print("Usage: /unequip <item name>");
		return false;
	end
	if(CursorHasItem()) then
		Print("It looks like you're already holding something.");
		return false;
	end
	if(not InventoryName_ID) then
		AutoEquip.Set = Thottbot_Profile("player");
	end
	local c = InventoryName_ID[msg];
	if(not c) then
		if(Thottbot.NeedScanProfile) then
			AutoEquip.Set = Thottbot_Profile("player");
			c = InventoryName_ID[msg];
		end
		if(not c) then
			Print("Item \""..msg.."\" not found!");
			return false;
		end
	end
	DebugPrint("Removing "..msg);
	PickupInventoryItem(c);
	return BagItem(msg);
end
-- unfinished
-- function Swap(msg)
--	 if(not msg or msg == "") then
--		 Print("Usage: /swap <item name>,<item name>");
--		 return false;
--	 end
--	 if(CursorHasItem()) then
--		 Print("It looks like you're already holding something.");
--		 return false;
--	 end
--	 if(not InventoryName_ID) then
--		 AutoEquip.Set = Thottbot_Profile("player");
--	 end
--	 local c = InventoryName_ID[msg];
--	 if(not c) then
--		 if(Thottbot.NeedScanProfile) then
--			 AutoEquip.Set = Thottbot_Profile("player");
--			 c = InventoryName_ID[msg];
--		 end
--		 if(not c) then
--			 Print("Item \""..msg.."\" not found!");
--			 return false;
--		 end
--	 end
--	 --dprint("Removing ",msg);
--	 PickupInventoryItem(c);
--	 return BagItem(msg);
-- end
function BagItem(msg)
	if(not msg) then
		dbanner("No msg passed to BagItem!");
		return false;
	end
	while(ContainerFree and ContainerFree.n > 0) do
		local f = ContainerFree[ContainerFree.n];
		if(not f) then
			dbanner("When trying to bagitem ",msg,", invalid containerfree record!");
		end
		ContainerFree.n = ContainerFree.n - 1;
		local t, itemCount = GetContainerItemInfo(f[1], f[2]);
		if(not itemCount) then
			PickupContainerItem(f[1],f[2]);
			InventoryName_ID[msg] = nil;
			if(not ContainerItem[msg]) then
				ContainerItem[msg] = {};
				ContainerItem[msg].n = 0;
			end
			push2(ContainerItem[msg],f[1],f[2]);
			return true;
		end
	end
	--dprint("BagItem error: no space to put ",msg);
	return false;	-- failed
end
function UnequipID(id)
	if(not InventoryName_ID) then
		AutoEquip.Set = Thottbot_Profile("player");
	end
	for key,value in InventoryName_ID do
		if(value == id) then
			return Unequip(key);
		end
	end
	return true;
end
function AutoEquip_Actionbar()
	if(UnitIsDeadOrGhost("player")) then
		return;
	end
	if(not AutoEquip.Running) then
		return;
	end
	if(AutoEquip.StanceEquip) then
		AutoEquip.Set = Thottbot_Profile("player");
		if(Cosmos_GetCVar("COS_AE_LOADERROR") == "0") then
			DebugPrint("SaveSet: "..AutoEquip.Stance);
			SaveSet(AutoEquip.Stance);
		end
		AutoEquip.Stance = AutoEquip_Stance();
		--dprint("LoadSet: ",AutoEquip.Stance);
		if(not LoadSet(AutoEquip.Stance,true)) then
			Print("Transformation loadset error!	It will not be saved.");
			Cosmos_SetCVar("COS_AE_LOADERROR","1");
		else
			Cosmos_SetCVar("COS_AE_LOADERROR","0");
		end
	end
end
--function AutoEquip_CacheEquipEnable(state)
--	if(state == 1 and not AutoEquip.CacheEquip) then
--		AutoEquip.CacheEquip = true;
--		if(AutoEquip.Running) then
--			Print("Equipment caching enabled.");
--		end
--		Thottbot_DoScans();
--	elseif(state == 0 and AutoEquip.CacheEquip) then
--		AutoEquip.CacheEquip = false;
--		if(Thottbot.Running) then
--			Print("Equipment caching disabled.");
--		end
--	end
--end
function AutoEquip_StanceEquipEnable(state)
	if(state == 1 and not AutoEquip.StanceEquip) then
		AutoEquip.StanceEquip = true;
		if(AutoEquip.Running) then
			Print("Auto-equip by stance/form enabled.");
		end
	elseif(state == 0 and AutoEquip.StanceEquip) then
		AutoEquip.StanceEquip = false;
		if(AutoEquip.Running) then
			Print("Auto-equip by stance/form disabled.");
		end
	end
end
function AutoEquip_Stance()
	for i=1, NUM_SHAPESHIFT_SLOTS do
		local texture, name, isActive, isCastable = GetShapeshiftFormInfo(i);
		if(isActive) then
			return name;
			----dprint("stance ",i);
			--return i;
		end
	end
	if(UnitClass("player") == "Druid") then
		return "2";
	else
		return "4";
	end
end
